unit Unit23;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Objects,
  FMX.Ani;

type
  TForm23 = class(TForm)
    ScreenLayout: TRectangle;
    Ship: TRectangle;
    Timer1: TTimer;
    BitmapListAnimation1: TBitmapListAnimation;
    Rectangle1: TRectangle;
    Rectangle2: TRectangle;
    Rectangle3: TRectangle;
    Rectangle4: TRectangle;
    Rectangle5: TRectangle;
    Rectangle6: TRectangle;
    Rectangle7: TRectangle;
    Rectangle8: TRectangle;
    Rectangle9: TRectangle;
    Rectangle10: TRectangle;
    Rectangle11: TRectangle;
    Rectangle12: TRectangle;
    Rectangle13: TRectangle;
    Rectangle14: TRectangle;
    Rectangle15: TRectangle;
    rMachine1: TRectangle;
    rMachine2: TRectangle;
    rMachine3: TRectangle;
    rMachine5: TRectangle;
    rMachine4: TRectangle;
    Rectangle31: TRectangle;
    Rectangle32: TRectangle;
    rTronco1: TRectangle;
    Rectangle34: TRectangle;
    Rectangle35: TRectangle;
    BitmapListAnimation2: TBitmapListAnimation;
    BitmapListAnimation3: TBitmapListAnimation;
    BitmapListAnimation4: TBitmapListAnimation;
    BMPDx: TBitmapListAnimation;
    BmpSx: TBitmapListAnimation;
    procedure Timer1Timer(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure BitmapListAnimation2Finish(Sender: TObject);
    procedure BitmapListAnimation3Finish(Sender: TObject);
    procedure BitmapListAnimation3Process(Sender: TObject);
    procedure BitmapListAnimation4Finish(Sender: TObject);
    procedure BitmapListAnimation4Process(Sender: TObject);
    procedure BmpSxProcess(Sender: TObject);
    procedure BmpSxFinish(Sender: TObject);
    procedure BMPDxProcess(Sender: TObject);
    procedure BMPDxFinish(Sender: TObject);
  private
    LeftButtonDown: Boolean;
    RightButtonDown: Boolean;
    UpButtonDown: Boolean;
    DownButtonDown: Boolean;
    PosY: Integer;
    PosX: integer;
    lOnTronco1: Boolean;
    lOnetime: Boolean;
    nIncrement: integer;
    obmpRana: TBitMap;
    procedure LeftDownEvent(Sender: TObject);
    procedure RightDownEvent(Sender: TObject);
    procedure LeftUpEvent(Sender: TObject);
    procedure RightUpEvent(Sender: TObject);
    procedure UpDownEvent(Sender: TObject);
    procedure UpUpEvent(Sender: TObject);
    procedure DownDownEvent(Sender: TObject);
    procedure DownUpEvent(Sender: TObject);

    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form23: TForm23;
  aRow: Array[0..12] of integer = (240, 220, 200, 180, 160, 140, 122, 104, 84, 64, 44, 24, 6);
  aCol: Array[0..14] of integer = (0, 16, 32, 48, 64,
                                   80, 96, 112, 128,
                                   144, 160, 176, 192, 208, 232);
//  aCol: Array[0..27] of integer = (0, 8, 16, 24, 32, 40, 48, 56,
//                                   64, 72, 80, 88, 96, 104, 112, 120,
//                                   128, 136, 144, 152, 160, 168, 176, 184,
//                                   192, 200, 208, 216);
implementation

{$R *.fmx}

procedure TForm23.Timer1Timer(Sender: TObject);
begin
  if (LeftButtonDown) then
  begin
    BmpSx.Enabled := True;
  end;

  if (RightButtonDown) then
  begin
    BMPDx.Enabled := true;
  end;

  if (UpButtonDown) then
  begin
    BitmapListAnimation3.Enabled := True;
//    Ship.Position.Y := aRow[PosY];
  end;

  if (DownButtonDown) then
  begin
    BitmapListAnimation4.Enabled := True;
  end;

  rMachine2.Position.X := rMachine2.Position.X + nIncrement;
  if rMachine2.Position.X >= 212  then
    rMachine2.Position.X := -15;

  rMachine1.Position.X := rMachine1.Position.X + ((nIncrement+1)*-1);
  if rMachine1.Position.X <= -8  then
    rMachine1.Position.X := 215;

  rMachine3.Position.X := rMachine3.Position.X + (nIncrement*-1);
  if rMachine3.Position.X <= -8  then
    rMachine3.Position.X := 215;

  rMachine4.Position.X := rMachine4.Position.X + ((nIncrement +1)*-1);
  if rMachine4.Position.X <= -8  then
    rMachine4.Position.X := 215;


  rMachine5.Position.X := rMachine5.Position.X + nIncrement;
  if rMachine5.Position.X >= 212  then
    rMachine5.Position.X := -15;

  if IntersectRect(Ship.BoundsRect, rMachine2.BoundsRect) then
  begin
    // esplosione ... vite - 1 ... reset
    BitmapListAnimation2.Enabled := True;
//    Timer1.Enabled := false;
//    ShowMessage('colpito');
  end;

  rTronco1.Position.X := rTronco1.Position.X + nIncrement;
  if rTronco1.Position.X >= 223  then
    rTronco1.Position.X := -50;

  if IntersectRect(Ship.BoundsRect, rTronco1.BoundsRect) then
  begin
    lOnTronco1 := True;
    Ship.Position.x := Ship.Position.x + nincrement;
    PosX := Round(Ship.Position.x) div 16;
  end
  else
    lOnTronco1 := False;

end;

procedure TForm23.FormKeyUp(Sender: TObject; var Key: Word; var KeyChar: Char;
  Shift: TShiftState);
begin
      case Key of
        vkUp:
          begin
            UpUpEvent(Sender);
          end;
        vkDown:
          begin
            DownUpEvent(Sender);
          end;
        vkLeft:
          begin
            LeftUpEvent(Sender);
          end;
        vkRight:
          begin
            RightUpEvent(Sender);
          end;
      end;
end;

procedure TForm23.FormCreate(Sender: TObject);
begin
  PosY := 0;
  PosX := 13;
  nIncrement := 2;
  Ship.Position.Y := aRow[PosY];
  Ship.Position.X := aCol[PosX];
  rMachine2.Position.X := 0;
  obmpRana := TBitMap.Create;
  obmpRana.Assign(ship.Fill.Bitmap.Bitmap);
end;

procedure TForm23.FormKeyDown(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
begin
  if (not RightButtonDown) and
     (not LeftButtonDown) and
     (not DownButtonDown) and
     (not UpButtonDown) then
      case Key of
        vkUp:
          begin
            UpDownEvent(Sender);
            PosY := PosY + 1;
          end;
        vkDown:
          begin
            DownDownEvent(Sender);
            PosY := PosY - 1;
          end;
        vkLeft:
          begin
            LeftDownEvent(Sender);
            if not lOnTronco1 then
              PosX := PosX - 1;
          end;
        vkRight:
          begin
            RightDownEvent(Sender);
            if not lOnTronco1 then
              PosX := PosX + 1;
          end;
      end;
end;

procedure TForm23.RightUpEvent(Sender: TObject);
begin
  RightButtonDown := False;
end;

procedure TForm23.DownUpEvent(Sender: TObject);
begin
  DownButtonDown := False;
end;

procedure TForm23.LeftUpEvent(Sender: TObject);
begin
  LeftButtonDown := False;
end;

procedure TForm23.UpUpEvent(Sender: TObject);
begin
 UpButtonDown := False;
end;

procedure TForm23.UpDownEvent(Sender: TObject);
begin
  RightButtonDown := False;
  LeftButtonDown := False;
  DownButtonDown := False;
  UpButtonDown := True;
end;

procedure TForm23.BitmapListAnimation2Finish(Sender: TObject);
begin
  BitmapListAnimation2.Enabled := False;
  Ship.Fill.Bitmap.Bitmap.Assign(obmpRana);
  PosY := 0;
  PosX := 13;
  Ship.Position.Y := aRow[PosY];
  Ship.Position.X := aCol[PosX];
end;

procedure TForm23.BitmapListAnimation3Finish(Sender: TObject);
begin
BitmapListAnimation3.Enabled := False;
end;

procedure TForm23.BitmapListAnimation3Process(Sender: TObject);
begin
    Ship.Position.Y := aRow[PosY];
end;

procedure TForm23.BitmapListAnimation4Finish(Sender: TObject);
begin
  BitmapListAnimation4.Enabled := false;
end;

procedure TForm23.BitmapListAnimation4Process(Sender: TObject);
begin
    Ship.Position.Y := aRow[PosY];
end;

procedure TForm23.BMPDxFinish(Sender: TObject);
begin
  BMPDx.Enabled := false;
  lOnetime := False;
end;

procedure TForm23.BMPDxProcess(Sender: TObject);
begin
  if lOnTronco1 then
  begin
    if not lOnetime then
    begin
      RightButtonDown := False;
      Ship.Position.X := Ship.Position.X + 16;
      lOnetime := True;
    end;
  end
  else
    Ship.Position.X := aCol[PosX];

end;

procedure TForm23.BmpSxFinish(Sender: TObject);
begin
  Bmpsx.Enabled := false;
  lOnetime := False;
end;

procedure TForm23.BmpSxProcess(Sender: TObject);
begin
  if lOnTronco1 then
  begin
    if not lOnetime then
    begin
      LeftButtonDown := False;
      Ship.Position.X := Ship.Position.X - 16;
      lOnetime := True;
    end;
  end
  else
    Ship.Position.X := aCol[PosX];
end;

procedure TForm23.DownDownEvent(Sender: TObject);
begin
  RightButtonDown := False;
  LeftButtonDown := False;
  UpButtonDown := False;
  DownButtonDown := True;
end;

procedure TForm23.LeftDownEvent(Sender: TObject);
begin
  RightButtonDown := False;
  LeftButtonDown := True;
  UpButtonDown := False;
  DownButtonDown := False;
end;

procedure TForm23.RightDownEvent(Sender: TObject);
begin
  LeftButtonDown := False;
  RightButtonDown := True;
  UpButtonDown := False;
  DownButtonDown := False;
end;


end.
